#include "Adafruit_EPD.h"
#include "Adafruit_SSD1675BX.h"
//#include "icm20602.h"
#include "badge_pins.h"


#include <SPI.h>
#include <Wire.h>

SPIClass SPI3(HSPI);

// DISPLAY
#define DISPLAY_WIDTH           ((int16_t)(296))
#define DISPLAY_HEIGHT          ((int16_t)(128))
#define DISPLAY_COLOR_BLACK     ((uint16_t)(0x0000))
#define DISPLAY_COLOR_WHITE     ((uint16_t)(0xffff))
#define DISPLAY_COLOR_RED       ((uint16_t)(0xf800))
Adafruit_SSD1675BX display(DISPLAY_WIDTH, DISPLAY_HEIGHT, EPD_DC, EPD_RESET, EPD_CS, SRAM_CS, EPD_BUSY, EPD_SPI);

// IMU
#define ESP32_I2C_IMU_ADDR      ((char)0x68)

void testdrawtext(const char *text, uint16_t color) {
  display.setCursor(0, 0);
  display.setTextColor(color);
  display.setTextWrap(true);
  display.print(text);
}

void setup() {
  // Debug serial port
  Serial.begin(115200);
  Serial.println("BSides badge starting up!");

  // ATMEL serial bridge
  Serial1.begin(115200, SERIAL_8N1, UART_RXD, UART_TXD);
  Serial.println("ATMEL Serial port started");
  
  //Serial.println("I2C Bus starting");
  // Access IMU via I2C
  //Wire.begin(ESP_SDA, ESP_SCL);

  
  
  // Set up Display
  Serial.print("Starting display... ");
  display.setRotation(0);
  display.clearBuffer();
  display.setMode(Adafruit_SSD1675BX::kModeBlackWhiteRed);
  display.begin();
  Serial.println("Done!");
  
  // Connect to Wifi
  // Connect to MQTT Broker
  // Subscribe to MQTT Topics of interest


}

void loop() {
  // don't do anything!
}
